<html>
<head>
	<title>Massey Sır Paylaşım Şeması</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<script type="text/javascript" src="jquery-1.10.2.js"></script>
	<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">
	<script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>

	<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
	<script type="text/javascript" src="calculationlib/ecclib.js"></script>
	<script type="text/javascript" src="calculationlib/polynomial.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
	<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
	<script type="text/x-mathjax-config">
		MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
		MathJax.Localization.setLocale("tr");
	</script>
	<script>
		var WriteFormula = function(divId, TeX) {
			var selector = "#" + divId;
			var selObj = $(selector)
			if(selObj.length > 0){
				var queue = MathJax.Hub.queue;
				var math = MathJax.Hub.getAllJax(divId)[0];
				queue.Push(
					function () { selObj.css('visibility','hidden') },
					//["resetEquationNumbers",MathJax.InputJax.TeX],
					["Text",math,"\\displaystyle{"+TeX+"}"],
					function () { selObj.css('visibility','visible') }
				);
			}
		}
		var AddFormula = function(container, name, tex) {
			var containerSelector = $('#' + container);
			if ($('#' + name).length == 0)
				containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
			else $('#' + name).html("");

			$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
			MathJax.Hub.Queue(
				//function () { $('#' + name).css('visibility','hidden')
				["Typeset",MathJax.Hub]
				//,function () { $('#' + name).css('visibility','visible') }
			);
		}
  </script>
</head>

<body>

	<h2>Massey Sır Paylaşım Şeması </h2>

	<h3>Sırı Oluşturma</h3>
	<div id="divConstSecretParams">
		<div class="row">
			<div class="col-md-2">  <strong>Katılımcı sayısı(n)</strong>  </div>
			<div class="col-md-4">  <input type="text" id="txtN" value="4"/> </div>
		</div>
		<div class="row">
			<div class="col-md-2">  <strong>Sır</strong>  </div>
			<div class="col-md-4">  <input type="text" id="txtSecret" value="1"/> </div>
		</div>
		<div class="row" id="divAccessSets">
			<div class="col-md-2">   </div>
			<div class="col-md-4">
				<table id="tableAccessSets" style="margin:10px" cellpadding="100px">
					<tr>
						<th style="padding-right:10px">P1</th>
						<th style="padding-right:10px">P2</th>
						<th style="padding-right:10px">P3</th>
						<th style="padding-right:10px">P4</th>
					</tr>
					<tr>
						<td><input type="checkbox" row='1' col='1' /></td>
						<td><input type="checkbox" row='1' col='2' /></td>
						<td><input type="checkbox" row='1' col='3' /></td>
						<td><input type="checkbox" row='1' col='4' /></td>
					</tr>
				</table>
			</div>
		</div>
		<div class="row">
			<div class="col-md-2"> </div>
			<div class="col-md-4">  <input type="button" id="btnAddAccessSet" value="Erişim Kümesi Ekle" />  </div>
		</div>
		<div class="row">
			<div class="col-md-2"> </div>
			<div class="col-md-4">  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </div>
		</div>
	</div>
	<div id="divConstSecretResult"></div>

	<h3>Sırrı Çözme</h3>
	<div id="divFindSecretParams">
		<b>q:</b> <input type='text' id='txtQ2' value='17'/> <br />
		<div id="divSecretInputs"></div>
		<input type='button' id='btnFindSecret' value='Sırrı Bul' />
	</div>
	<div id="divFindSecretResult"></div>


	<script type="text/javascript">
		rowCount = 1;
		AuMatrixes = {};
		
		var AddAccessSetInput = function(tableId, count, rowId){
			var text = "<tr>";
			for (var i = 1; i < count+1; i++){
				text += "<td> <input type='checkbox' row='" + rowId + "' col='" + i + "' /> </td>"
			}
			text += "</tr>";
			$('#' + tableId + ' tr:last').after(text);
		}
		var CreateInput = function(inputCount, q) {

			var text = "<table>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td align='center'>" + i + "</td>";
			text += "</tr>";

			text += "<tr>";
			for (var i = 1; i < inputCount+1; i++)
				text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
			text += "</tr>";

			text += "</table>";
			return text;
		}
		

		$(document).ready(function () {
			$("input[type='button']").click(function (e) {
				if (e.target.id == "btnConstructSecret") {

					var q = 2;
					var N = parseInt($('#txtN').val());
					var secret = parseInt($('#txtSecret').val());
					var generator = new MatrixGenerator(q);
					var processor = new MatrixCalculator(q);

					var contains = function(list, value) {
						for (var i = 0; i < list.length; i++){
							if (list[i].Equals(value))
								return true;
						}
						return false;
					}
					
					var codewords = [];
					for (var i = 1; i < rowCount + 1; i++){
						var checkboxes = $("input[row=" + i + "]");
						var arr = Array(N+1).fill(0);
						arr[0] = 1;
						checkboxes.each(function(i,e){
							arr[e.getAttribute("col")] = e.checked ? 1 : 0;
						});
						
						var codeword = new CodeWord(new Matrix(arr));
						if (!contains(codewords, codeword))
							codewords.push(codeword);
            
					}

					for (var i = 0; i < codewords.length; i++){
						for (var j = 0; j < codewords.length; j++){
							var c1 = codewords[i].Data;
							var c2 = codewords[j].Data;
							var sum = new CodeWord(processor.Add(c1, c2));
							if(!contains(codewords, sum))
								codewords.push(sum);
						}
					}

					var codewordsText = "C^{\\bot}=\\{";
					for (var i = 0; i < codewords.length; i++){
						codewordsText += codewords[i].Text + ", ";
					}
					codewordsText = codewordsText.substring(0, codewordsText.length-2);
					codewordsText += "\\}";
					AddFormula("divConstSecretResult", "codewordsText", codewordsText);

					var k = Math.log(codewords.length) / Math.log(2);
					AddFormula("divConstSecretResult", "kValue", "k=" + k);

					var zeroCodeword = new CodeWord(new Matrix(Array(N+1).fill(0)));
					var getGeneratorMatrix = function(codewords, k) {
						var i = 0;
						if (codewords[i].Equals(zeroCodeword))
							i++;
						var rows = new Matrix(codewords[i++].Data.GetRow(0));
						for (i = 1; i < k; i++){
							if (codewords[i].Equals(zeroCodeword))
								continue;
							rows = rows.AddBottom(new Matrix(codewords[i].Data.GetRow(0)));
							var val = processor.Eliminate(rows);
							var cw = new CodeWord(val.GetRow(val.RowCount-1));
							if (cw.Equals(zeroCodeword)){
								row.RemoveRow(i);
								i--;
							}
							else {
								if (rows.RowCount == k)
									return rows;
							}
						}
						return rows;
					}
					var H = getGeneratorMatrix(codewords, k);
					AddFormula("divConstSecretResult", "HMatrix", "H=" + H.ToLatex());

					var dualCode = new ErrorCorrectingCode(H, 2);
					var G = dualCode.ParityCheck;

					$("#divSecretInputs").html(CreateInput(N, q));
				}
				else if (e.target.id == "btnFindSecret") {

					var q = parseInt($('#txtQ2').val());
					var generator = new MatrixGenerator(q);
					var processor = new MatrixCalculator(q);

					var indices = [];
					var vectors = [];
					var values = [];
					$("[id^=txtInpt]").each(function() {
						if (!isNaN(parseInt($(this).val()))) {
							var i = parseInt($(this).attr('num'));
							var value =  parseInt($(this).val());
							indices.push(i);
							values.push(value);
							vectors.push(AuMatrixes[i]);
						}
					});

					var t = vectors.length;

					var Mw = vectors[0];
					for (var i = 1; i  < t; i++)
						Mw = Mw.AddBottom(vectors[i]);
					var det = processor.Determinant(Mw);

					var y = new Matrix(values).Transpose();
					var textX = new MatrixGenerator().Pattern(t, 1, function(i,j) { return "x_{" + i + "}"; }).ToLatex();
					var textResult = Mw.ToLatex() + textX + "=" + y.ToLatex() + "\\\\Determinant= " + det;
					AddFormula("divFindSecretResult", "divMat_Result1", textResult);

					var X = processor.Solve(Mw, y);
					var textResult = "X=" + X.ToLatex();
					AddFormula("divFindSecretResult", "divMat_ResultX", textResult);

				}
				else if (e.target.id == "btnAddAccessSet"){
					rowCount++;
					var N = parseInt($('#txtN').val());
					AddAccessSetInput("divAccessSets", N, rowCount);
				}
			});
		});
	</script>
</body>

</html>
